import java.util.ArrayList;
import java.lang.Math ;

public class FoodPelets {

    public class Cordinate {
        public double x ;
        public double y ;

        public Cordinate(double w, double h) {
            x = w ;
            y = h ;
        }

    }

    private Turtle foodTur ;
    private ArrayList<Cordinate> food ;
    private int index = -1 ;


    // methods

    public FoodPelets(Turtle foodTurtle) {
        // This class needs a turtle to act as the food 
        // for the screen.
        // !! This needs to be a different turtle other than 
        foodTur = foodTurtle ;
        food = new ArrayList<Cordinate>() ;
        foodTur.hide() ;
        foodTur.up() ;

    }

    public boolean atFood(double x, double y) {
        // You call this function to check if the turtle 
        // is at a food pelet it can eat.
        // it needs to know what the turtles location is to 
        // check
        double distance ;
        if (food.size() > 0) {
            for (int i = 0; i < food.size(); i++) {
                // for each food, we need to check if there if the turtle is close enough.
                distance = Math.pow(x-(food.get(i).x), 2) + Math.pow(y-(food.get(i).y), 2) ;
                //System.out.println(distance) ;
                if (distance <= 80.0) {
                    index = i ;
                    return true ;
                }

            }
            return false ;
        }
        else {
            System.out.println("No food is being tracked") ;
            return false ;
        }
    }

    public boolean eatFood(double x, double y) {
        // You can call this function to eat the food.
        // it will only work if the turtle is at the food.
        // returns true if food was eaten.
        if (atFood(x, y)) {
            //index is set.
            foodTur.setPosition(food.get(index).x, food.get(index).y) ;
            foodTur.dot("white", 7.0) ;
            foodTur.home() ;
            food.remove(index) ;
            return true ;
        }
        else {
            return false ;
        }
        
    }

    public void setFood(double x, double y) {
        // Call this function to set food an cordinate (x,y)
        food.add(new Cordinate(x, y)) ;
        foodTur.setPosition(x, y) ;
        foodTur.dot() ;
        foodTur.home() ;
    }
}
